/*
 * Copyright (C) 2005-2013 Schlichtherle IT Services.
 * All rights reserved. Use is subject to license terms.
 */
package net.java.truelicense.json.codec;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;
import java.io.IOException;
import javax.annotation.concurrent.Immutable;
import javax.security.auth.x500.X500Principal;

/**
 * A JSON serializer for {@link X500Principal}s.
 * <p>
 * This type of JSON serializer is used for V2/JSON format license keys.
 *
 * @author Christian Schlichtherle
 */
@Immutable
public final class X500PrincipalSerializer
extends StdSerializer<X500Principal> {

    public X500PrincipalSerializer() { super(X500Principal.class); }

    @Override
    public void serialize(
            X500Principal value,
            JsonGenerator jgen,
            SerializerProvider provider)
    throws IOException {
        jgen.writeString(value.getName());
    }
}
